<html>
<head>
<title>OgreAnimable.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreAnimable.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreAnimable_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __ANIMABLE_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __ANIMABLE_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector2_8h.html">OgreVector2.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector4_8h.html">OgreVector4.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreQuaternion_8h.html">OgreQuaternion.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreColourValue_8h.html">OgreColourValue.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringVector_8h.html">OgreStringVector.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgreException_8h.html">OgreException.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="OgreAny_8h.html">OgreAny.h</a>&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="keyword">namespace </span>Ogre {
<a name="l00071"></a><a class="code" href="classOgre_1_1AnimableValue.html">00071</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1AnimableValue.html" title="Defines an object property which is animable, i.e.">AnimableValue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AnimableAlloc</a>
<a name="l00072"></a>00072     {
<a name="l00073"></a>00073     <span class="keyword">public</span>:
<a name="l00075"></a><a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69">00075</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69" title="The type of the value being animated.">ValueType</a>
<a name="l00076"></a>00076         {
<a name="l00077"></a><a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69af2f0a37077706342371d65539e56b295">00077</a>             <a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69af2f0a37077706342371d65539e56b295">INT</a>,
<a name="l00078"></a><a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69a3062c18887fcc426f17c19d786edeaef">00078</a>             <a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69a3062c18887fcc426f17c19d786edeaef">REAL</a>,
<a name="l00079"></a><a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69a31cb7b9505f0707baee335b0b200a135">00079</a>             <a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69a31cb7b9505f0707baee335b0b200a135">VECTOR2</a>,
<a name="l00080"></a><a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69a4f77f4de37ff20785d425d00dde7864a">00080</a>             <a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69a4f77f4de37ff20785d425d00dde7864a">VECTOR3</a>,
<a name="l00081"></a><a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69a8c429058bd40804133f32ee95337f05b">00081</a>             <a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69a8c429058bd40804133f32ee95337f05b">VECTOR4</a>,
<a name="l00082"></a><a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69ac56bb2149a2092c3a3d834c6def9571a">00082</a>             <a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69ac56bb2149a2092c3a3d834c6def9571a">QUATERNION</a>,
<a name="l00083"></a><a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69a019d638a0420937709b0ca4ded01a57e">00083</a>             <a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69a019d638a0420937709b0ca4ded01a57e">COLOUR</a>,
<a name="l00084"></a><a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69a6821a401bbbad6d7649104b0978c4216">00084</a>             <a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69a6821a401bbbad6d7649104b0978c4216">RADIAN</a>,
<a name="l00085"></a><a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69a67875f169fb2deebc7c3590efbe621f1">00085</a>             DEGREE
<a name="l00086"></a>00086         };
<a name="l00087"></a>00087     <span class="keyword">protected</span>:
<a name="l00089"></a><a class="code" href="classOgre_1_1AnimableValue.html#aa3a3dfd661bd4fe6c7a64d12a1f99e25">00089</a>         <a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69" title="The type of the value being animated.">ValueType</a> <a class="code" href="classOgre_1_1AnimableValue.html#aa3a3dfd661bd4fe6c7a64d12a1f99e25" title="Value type.">mType</a>;
<a name="l00090"></a>00090 
<a name="l00092"></a>00092         <span class="keyword">union</span>
<a name="l00093"></a>00093         {
<a name="l00094"></a><a class="code" href="classOgre_1_1AnimableValue.html#ad8012b223d250f482cd3200ed450a36a">00094</a>             <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1AnimableValue.html#ad8012b223d250f482cd3200ed450a36a">mBaseValueInt</a>;
<a name="l00095"></a><a class="code" href="classOgre_1_1AnimableValue.html#a4e26a76b98c42eda570e551322aff11d">00095</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mBaseValueReal[4];
<a name="l00096"></a>00096         };
<a name="l00097"></a>00097 
<a name="l00099"></a><a class="code" href="classOgre_1_1AnimableValue.html#aacef098935627873fd41f7b3bd37d3cf">00099</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#aacef098935627873fd41f7b3bd37d3cf" title="Internal method to set a value as base.">setAsBaseValue</a>(<span class="keywordtype">int</span> val) { mBaseValueInt = val; }
<a name="l00101"></a><a class="code" href="classOgre_1_1AnimableValue.html#a591cf1fe6aea2bb616b2fb33aa9d89eb">00101</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a591cf1fe6aea2bb616b2fb33aa9d89eb" title="Internal method to set a value as base.">setAsBaseValue</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> val) { mBaseValueReal[0] = val; }
<a name="l00103"></a><a class="code" href="classOgre_1_1AnimableValue.html#a4d7deaff8c80d30847824641a1379795">00103</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAsBaseValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; val) 
<a name="l00104"></a>00104         { memcpy(mBaseValueReal, val.<a class="code" href="classOgre_1_1Vector2.html#a307ca54d90a1a35b54a5416810681b3a" title="Pointer accessor for direct copying.">ptr</a>(), <span class="keyword">sizeof</span>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)*2); }
<a name="l00106"></a><a class="code" href="classOgre_1_1AnimableValue.html#a79e47a48705265f9d68da37c135d8e07">00106</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAsBaseValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; val) 
<a name="l00107"></a>00107         { memcpy(mBaseValueReal, val.<a class="code" href="classOgre_1_1Vector3.html#a7952f09744c63b5230ba4ea4b2c2d00a" title="Pointer accessor for direct copying.">ptr</a>(), <span class="keyword">sizeof</span>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)*3); }
<a name="l00109"></a><a class="code" href="classOgre_1_1AnimableValue.html#ad8b0a714cd9e968c50aba63e073a178e">00109</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAsBaseValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp; val) 
<a name="l00110"></a>00110         { memcpy(mBaseValueReal, val.<a class="code" href="classOgre_1_1Vector4.html#ae8a0fc61bcae1449c843b3c5430cef1f" title="Pointer accessor for direct copying.">ptr</a>(), <span class="keyword">sizeof</span>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)*4); }
<a name="l00112"></a><a class="code" href="classOgre_1_1AnimableValue.html#adb6ffb64834d5c87d4f700cd49d8187c">00112</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAsBaseValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; val) 
<a name="l00113"></a>00113         { memcpy(mBaseValueReal, val.<a class="code" href="classOgre_1_1Quaternion.html#aecce24dd0096766de0c96c13b195b197" title="Pointer accessor for direct copying.">ptr</a>(), <span class="keyword">sizeof</span>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)*4); }
<a name="l00115"></a>00115         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAsBaseValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; val);
<a name="l00117"></a><a class="code" href="classOgre_1_1AnimableValue.html#a27a8718feccb76cfe4d541a336bfb6a8">00117</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAsBaseValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; val)
<a name="l00118"></a>00118         { 
<a name="l00119"></a>00119             mBaseValueReal[0] = val.<a class="code" href="classOgre_1_1ColourValue.html#a6e086633637e335238d517e0ec9f2cd2">r</a>;
<a name="l00120"></a>00120             mBaseValueReal[1] = val.<a class="code" href="classOgre_1_1ColourValue.html#a13fbd050af26b8bd549ccb46aa699e07">g</a>;
<a name="l00121"></a>00121             mBaseValueReal[2] = val.<a class="code" href="classOgre_1_1ColourValue.html#aae078d77b654f76e3b760174f93474ec">b</a>;
<a name="l00122"></a>00122             mBaseValueReal[3] = val.<a class="code" href="classOgre_1_1ColourValue.html#a854058a76927880ae345ac1c465f9713">a</a>;
<a name="l00123"></a>00123         }
<a name="l00125"></a><a class="code" href="classOgre_1_1AnimableValue.html#aedb01dc3c980da9d66060621bad6789a">00125</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAsBaseValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; val)
<a name="l00126"></a>00126         { 
<a name="l00127"></a>00127             mBaseValueReal[0] = val.<a class="code" href="classOgre_1_1Radian.html#ae48b00b9345103217741b497108848d2">valueRadians</a>();
<a name="l00128"></a>00128         }
<a name="l00130"></a><a class="code" href="classOgre_1_1AnimableValue.html#a3331382a6e5baf2fdd863b92a27eeb3f">00130</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAsBaseValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Degree.html" title="Wrapper class which indicates a given angle value is in Degrees.">Degree</a>&amp; val)
<a name="l00131"></a>00131         { 
<a name="l00132"></a>00132             mBaseValueReal[0] = val.<a class="code" href="group__Math.html#gabb43fc06a3c963e8ba7aa96614d3a620">valueRadians</a>();
<a name="l00133"></a>00133         }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136     <span class="keyword">public</span>:
<a name="l00137"></a><a class="code" href="classOgre_1_1AnimableValue.html#a280f34861f78ae0f9560ce6d49bd2346">00137</a>         <a class="code" href="classOgre_1_1AnimableValue.html#a280f34861f78ae0f9560ce6d49bd2346">AnimableValue</a>(<a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69" title="The type of the value being animated.">ValueType</a> t) : mType(t) {}
<a name="l00138"></a><a class="code" href="classOgre_1_1AnimableValue.html#a89c0b065a5d1a3398e2663713bdf5007">00138</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1AnimableValue.html#a89c0b065a5d1a3398e2663713bdf5007">~AnimableValue</a>() {}
<a name="l00139"></a>00139 
<a name="l00141"></a><a class="code" href="classOgre_1_1AnimableValue.html#a801dea01990f3cb16def8185159a9e55">00141</a>         <a class="code" href="classOgre_1_1AnimableValue.html#adccd62bb2b72c602b9c59ca651256d69" title="The type of the value being animated.">ValueType</a> <a class="code" href="classOgre_1_1AnimableValue.html#a801dea01990f3cb16def8185159a9e55" title="Gets the value type of this animable value.">getType</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mType; }
<a name="l00142"></a>00142 
<a name="l00144"></a>00144         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCurrentStateAsBaseValue(<span class="keywordtype">void</span>) = 0;
<a name="l00145"></a>00145 
<a name="l00147"></a><a class="code" href="classOgre_1_1AnimableValue.html#a7bf19d59335bc397010e009eaf593288">00147</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a7bf19d59335bc397010e009eaf593288" title="Set value.">setValue</a>(<span class="keywordtype">int</span>) {
<a name="l00148"></a>00148             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00149"></a>00149         }
<a name="l00151"></a><a class="code" href="classOgre_1_1AnimableValue.html#a950b8bf6bd5090aa8717215dcba68877">00151</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a950b8bf6bd5090aa8717215dcba68877" title="Set value.">setValue</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>) {
<a name="l00152"></a>00152             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00153"></a>00153         }
<a name="l00155"></a><a class="code" href="classOgre_1_1AnimableValue.html#a4b0159d919981f3e5f6c69461bda725f">00155</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a4b0159d919981f3e5f6c69461bda725f" title="Set value.">setValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp;) {
<a name="l00156"></a>00156             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00157"></a>00157         }
<a name="l00159"></a><a class="code" href="classOgre_1_1AnimableValue.html#a8beaf446718c7169fd6e8580b5a0fa4e">00159</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a8beaf446718c7169fd6e8580b5a0fa4e" title="Set value.">setValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp;) {
<a name="l00160"></a>00160             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00161"></a>00161         }
<a name="l00163"></a><a class="code" href="classOgre_1_1AnimableValue.html#a8d6e93903faee8c7a0e557e4852111f9">00163</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a8d6e93903faee8c7a0e557e4852111f9" title="Set value.">setValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp;) {
<a name="l00164"></a>00164             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00165"></a>00165         }
<a name="l00167"></a><a class="code" href="classOgre_1_1AnimableValue.html#a61de4fd8eca078570639cb200178a40d">00167</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a61de4fd8eca078570639cb200178a40d" title="Set value.">setValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp;) {
<a name="l00168"></a>00168             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00169"></a>00169         }
<a name="l00171"></a><a class="code" href="classOgre_1_1AnimableValue.html#a39c32d892f553e9aa1f45091edabeb74">00171</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a39c32d892f553e9aa1f45091edabeb74" title="Set value.">setValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp;) {
<a name="l00172"></a>00172             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00173"></a>00173         }
<a name="l00175"></a><a class="code" href="classOgre_1_1AnimableValue.html#a1eb74e53e38812bc97931068a4a538db">00175</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a1eb74e53e38812bc97931068a4a538db" title="Set value.">setValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp;) {
<a name="l00176"></a>00176             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00177"></a>00177         }
<a name="l00179"></a><a class="code" href="classOgre_1_1AnimableValue.html#ae0bac21aa939447bb48efa668a7b9da4">00179</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#ae0bac21aa939447bb48efa668a7b9da4" title="Set value.">setValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Degree.html" title="Wrapper class which indicates a given angle value is in Degrees.">Degree</a>&amp;) {
<a name="l00180"></a>00180             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00181"></a>00181         }
<a name="l00183"></a>00183         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; val);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185         <span class="comment">// reset to base value</span>
<a name="l00186"></a>00186         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resetToBaseValue(<span class="keywordtype">void</span>);
<a name="l00187"></a>00187 
<a name="l00189"></a><a class="code" href="classOgre_1_1AnimableValue.html#a0077811577a67da9e17fe0582eddf9d0">00189</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a0077811577a67da9e17fe0582eddf9d0" title="Apply delta value.">applyDeltaValue</a>(<span class="keywordtype">int</span>) {
<a name="l00190"></a>00190             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00191"></a>00191         }
<a name="l00193"></a><a class="code" href="classOgre_1_1AnimableValue.html#a87058d1fc51ccbdeeb7d265d3bc6118a">00193</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a87058d1fc51ccbdeeb7d265d3bc6118a" title="Set value.">applyDeltaValue</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>) {
<a name="l00194"></a>00194             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00195"></a>00195         }
<a name="l00197"></a><a class="code" href="classOgre_1_1AnimableValue.html#a59283e8287fd1e9dc82c02f843809407">00197</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a59283e8287fd1e9dc82c02f843809407" title="Apply delta value.">applyDeltaValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp;) {
<a name="l00198"></a>00198             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00199"></a>00199         }
<a name="l00201"></a><a class="code" href="classOgre_1_1AnimableValue.html#abb5b33797a6afb9fedbbc12a83c2201e">00201</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#abb5b33797a6afb9fedbbc12a83c2201e" title="Apply delta value.">applyDeltaValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp;) {
<a name="l00202"></a>00202             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00203"></a>00203         }
<a name="l00205"></a><a class="code" href="classOgre_1_1AnimableValue.html#a4fe4b177fb24522f3e1325a6e8daab62">00205</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a4fe4b177fb24522f3e1325a6e8daab62" title="Apply delta value.">applyDeltaValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>&amp;) {
<a name="l00206"></a>00206             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00207"></a>00207         }
<a name="l00209"></a><a class="code" href="classOgre_1_1AnimableValue.html#a7db4121de1ba46cbf27fb9d8a0365cf2">00209</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a7db4121de1ba46cbf27fb9d8a0365cf2" title="Apply delta value.">applyDeltaValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp;) {
<a name="l00210"></a>00210             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00211"></a>00211         }
<a name="l00213"></a><a class="code" href="classOgre_1_1AnimableValue.html#ad131854d6fc1551de763ea93634d618c">00213</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#ad131854d6fc1551de763ea93634d618c" title="Apply delta value.">applyDeltaValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp;) {
<a name="l00214"></a>00214             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00215"></a>00215         }
<a name="l00217"></a><a class="code" href="classOgre_1_1AnimableValue.html#a8a546dead00468e8de1a93a853c5bb59">00217</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a8a546dead00468e8de1a93a853c5bb59" title="Apply delta value.">applyDeltaValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Degree.html" title="Wrapper class which indicates a given angle value is in Degrees.">Degree</a>&amp;) {
<a name="l00218"></a>00218             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00219"></a>00219         }
<a name="l00221"></a><a class="code" href="classOgre_1_1AnimableValue.html#a83b671f2ba59e036b6256ad64cca2ffe">00221</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableValue.html#a83b671f2ba59e036b6256ad64cca2ffe" title="Apply delta value.">applyDeltaValue</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp;) {
<a name="l00222"></a>00222             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9e2cd2d2436678236e339e6a42887090">Exception::ERR_NOT_IMPLEMENTED</a>, <span class="stringliteral">&quot;&quot;</span>, <span class="stringliteral">&quot;&quot;</span>);
<a name="l00223"></a>00223         }
<a name="l00225"></a>00225         <span class="keyword">virtual</span> <span class="keywordtype">void</span> applyDeltaValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; val);
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228     };
<a name="l00229"></a>00229 
<a name="l00230"></a><a class="code" href="group__Animation.html#ga5e0882c3b9f7ca32a795f98cf034e428">00230</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html">SharedPtr&lt;AnimableValue&gt;</a> <a class="code" href="group__Animation.html#ga5e0882c3b9f7ca32a795f98cf034e428">AnimableValuePtr</a>;
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00237"></a><a class="code" href="classOgre_1_1AnimableObject.html">00237</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1AnimableObject.html" title="Defines an interface to classes which have one or more AnimableValue instances to expose...">AnimableObject</a>
<a name="l00238"></a>00238     {
<a name="l00239"></a>00239     <span class="keyword">protected</span>:
<a name="l00240"></a><a class="code" href="classOgre_1_1AnimableObject.html#ab2ea54bb7c39f7640f71be8bb2f8b0a5">00240</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">map&lt;String, StringVector&gt;::type</a> <a class="code" href="classOgre_1_1AnimableObject.html#ab2ea54bb7c39f7640f71be8bb2f8b0a5">AnimableDictionaryMap</a>;
<a name="l00242"></a><a class="code" href="classOgre_1_1AnimableObject.html#a1e2b199b8a10c3753ebeecc8fa773620">00242</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1AnimableObject.html#ab2ea54bb7c39f7640f71be8bb2f8b0a5">AnimableDictionaryMap</a> <a class="code" href="classOgre_1_1AnimableObject.html#a1e2b199b8a10c3753ebeecc8fa773620" title="Static map of class name to list of animable value names.">msAnimableDictionary</a>;
<a name="l00248"></a><a class="code" href="classOgre_1_1AnimableObject.html#a7748b5ea03ba5eb10fdd79e455f96443">00248</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getAnimableDictionaryName(<span class="keywordtype">void</span>)<span class="keyword"> const </span>
<a name="l00249"></a>00249 <span class="keyword">        </span>{ <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>; }
<a name="l00253"></a><a class="code" href="classOgre_1_1AnimableObject.html#a83629c5c4708cebd10c358a4be0722f5">00253</a>         <span class="keywordtype">void</span> createAnimableDictionary(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00254"></a>00254 <span class="keyword">        </span>{
<a name="l00255"></a>00255             <span class="keywordflow">if</span> (msAnimableDictionary.find(getAnimableDictionaryName()) 
<a name="l00256"></a>00256                 == msAnimableDictionary.end())
<a name="l00257"></a>00257             {
<a name="l00258"></a>00258                 <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> vec;
<a name="l00259"></a>00259                 initialiseAnimableDictionary(vec);
<a name="l00260"></a>00260                 msAnimableDictionary[getAnimableDictionaryName()] = vec;
<a name="l00261"></a>00261             }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263         }
<a name="l00264"></a>00264     
<a name="l00266"></a><a class="code" href="classOgre_1_1AnimableObject.html#a20139173e816c296ab46d0548d1d4902">00266</a>         <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>&amp; _getAnimableValueNames(<span class="keywordtype">void</span>)
<a name="l00267"></a>00267         {
<a name="l00268"></a>00268             AnimableDictionaryMap::iterator i = 
<a name="l00269"></a>00269                 msAnimableDictionary.find(getAnimableDictionaryName());
<a name="l00270"></a>00270             <span class="keywordflow">if</span> (i != msAnimableDictionary.end())
<a name="l00271"></a>00271             {
<a name="l00272"></a>00272                 <span class="keywordflow">return</span> i-&gt;second;
<a name="l00273"></a>00273             }
<a name="l00274"></a>00274             <span class="keywordflow">else</span>
<a name="l00275"></a>00275             {
<a name="l00276"></a>00276                 OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9f57f8f4aefb7fae5fcd69fe155e7003">Exception::ERR_ITEM_NOT_FOUND</a>, 
<a name="l00277"></a>00277                     <span class="stringliteral">&quot;Animable value list not found for &quot;</span> + getAnimableDictionaryName(), 
<a name="l00278"></a>00278                     <span class="stringliteral">&quot;AnimableObject::getAnimableValueNames&quot;</span>);
<a name="l00279"></a>00279             }
<a name="l00280"></a>00280 
<a name="l00281"></a>00281         }
<a name="l00282"></a>00282 
<a name="l00286"></a><a class="code" href="classOgre_1_1AnimableObject.html#a80abf1736a4241c432b30d2073c7a263">00286</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimableObject.html#a80abf1736a4241c432b30d2073c7a263" title="Internal method for initialising dictionary; should be implemented by subclasses wanting to expose an...">initialiseAnimableDictionary</a>(<a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>&amp;)<span class="keyword"> const </span>{}
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 
<a name="l00289"></a>00289     <span class="keyword">public</span>:
<a name="l00290"></a><a class="code" href="classOgre_1_1AnimableObject.html#acc4f830de60e226fbed772610eea93a4">00290</a>         <a class="code" href="classOgre_1_1AnimableObject.html#acc4f830de60e226fbed772610eea93a4">AnimableObject</a>() {}
<a name="l00291"></a><a class="code" href="classOgre_1_1AnimableObject.html#ac61ca9c912e6b00bbe4fdd9ee0e56079">00291</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1AnimableObject.html#ac61ca9c912e6b00bbe4fdd9ee0e56079">~AnimableObject</a>() {}
<a name="l00292"></a>00292 
<a name="l00294"></a><a class="code" href="classOgre_1_1AnimableObject.html#a4239d192b2b08c4970dfaa22ce5a0cd0">00294</a>         <span class="keyword">const</span> <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>&amp; getAnimableValueNames(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00295"></a>00295 <span class="keyword">        </span>{
<a name="l00296"></a>00296             createAnimableDictionary();
<a name="l00297"></a>00297 
<a name="l00298"></a>00298             AnimableDictionaryMap::iterator i = 
<a name="l00299"></a>00299                 msAnimableDictionary.find(getAnimableDictionaryName());
<a name="l00300"></a>00300             <span class="keywordflow">if</span> (i != msAnimableDictionary.end())
<a name="l00301"></a>00301             {
<a name="l00302"></a>00302                 <span class="keywordflow">return</span> i-&gt;second;
<a name="l00303"></a>00303             }
<a name="l00304"></a>00304             <span class="keywordflow">else</span>
<a name="l00305"></a>00305             {
<a name="l00306"></a>00306                 OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9f57f8f4aefb7fae5fcd69fe155e7003">Exception::ERR_ITEM_NOT_FOUND</a>, 
<a name="l00307"></a>00307                     <span class="stringliteral">&quot;Animable value list not found for &quot;</span> + getAnimableDictionaryName(), 
<a name="l00308"></a>00308                     <span class="stringliteral">&quot;AnimableObject::getAnimableValueNames&quot;</span>);
<a name="l00309"></a>00309             }
<a name="l00310"></a>00310 
<a name="l00311"></a>00311         }
<a name="l00312"></a>00312 
<a name="l00319"></a><a class="code" href="classOgre_1_1AnimableObject.html#ab2cfac9af1b0d71c780ec969166b3585">00319</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">AnimableValuePtr</a> createAnimableValue(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; valueName)
<a name="l00320"></a>00320         {
<a name="l00321"></a>00321             OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba9f57f8f4aefb7fae5fcd69fe155e7003">Exception::ERR_ITEM_NOT_FOUND</a>, 
<a name="l00322"></a>00322                 <span class="stringliteral">&quot;No animable value named &#39;&quot;</span> + valueName + <span class="stringliteral">&quot;&#39; present.&quot;</span>, 
<a name="l00323"></a>00323                 <span class="stringliteral">&quot;AnimableObject::createAnimableValue&quot;</span>);
<a name="l00324"></a>00324         }
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328     };
<a name="l00329"></a>00329 
<a name="l00333"></a>00333 }
<a name="l00334"></a>00334 <span class="preprocessor">#endif</span>
<a name="l00335"></a>00335 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
